import vesta.*;
import vesta.ctmc.*;
import vesta.mc.*;
public class Polling extends Ctmc {
    public int n;

    public double mu = 1;
    public double gamma = 200;
    public double lambda;

    public int s;
    public int a;
    public int[] si;


public Polling( 
){

        this.n = 18;
        si = new int[n];
        lambda = 1.0 / n;
        for (int j = 0; j < n; j++) si[j] = 1;
        s = 1;
        a = 1;


setDtmc(false);
}

public void action(int k){
	int i=0;

	if (k==-1){
		if( a == 0 && si[s - 1] == 0
) addRate( gamma
,i);
	} else if(k==i) {
            s = s + 1;
            if (s > n) s = 1;


	}
i++;
	if (k==-1){
		if( a == 0 && si[s - 1] == 1
) addRate( gamma
,i);
	} else if(k==i) {
            a = 1;


	}
i++;
	if (k==-1){
		if( a == 1 && si[s - 1] == 1
) addRate( mu
,i);
	} else if(k==i) {
 si[s - 1] = 0;
            s = s + 1;
            if (s > n) s = 1;
            a = 0;


	}
i++;
 for(int j=0;j<n;j++){

	if (k==-1){
		if( true
) addRate( lambda
,i);
	} else if(k==i) {
 si[s - 1] = 1;

	}
i++;
 }


}

public boolean sat(int i){
if (i==0) return  s == 1 && a == 0
;
if (i==1) return  s == 2 && a == 0
;
if (i==2) return  s == 1 && a == 1
;
if (i==3) return  s == 2 && a == 1
;
if (i==4) return  s == 1 
;
if (i==5) return  s == 0
;
throw new AnyException("Unknown atomic proposition "+i);
}
public double rval(int i){ throw new AnyException("Unknown state value  "+i);}
public int ival(int i){ return 0;}
}
